=== debian/changelog ===
halide (13.0.3-2) unstable; urgency=medium

  * Declare missing Breaks+Replaces on halide13-api-doc. Fixes #1003424.
  * Drop liblld dependency - only needed for WebAssembly,
    but we don't build that anyway.
  * Don't enable LLD/PGO on some more architectures where that fails.
  * Fine-tune some more missing dependencies.

 -- Roman Lebedev <lebedev.ri@gmail.com>  Mon, 10 Jan 2022 12:15:10 +0300

halide (13.0.3-1) unstable; urgency=medium

  * Update to latest upstream release, refresh patches.
  * Package Python3 bindings.
    Thanks goes to Mark Glines for bringing this up initially.
  * Split Doxygen API docs into their own package, separate from C++ tutorials.
  * Package Python3 tutorials.
  * Yet another RISC-V build fix.
  * Don't hard-require libomp, it isn't strictly needed.
  * Explicitly overrule DEB_BUILD_MAINT_OPTIONS's request to do LTO,
    since we do our own LTO handling. Might fix Ubuntu build.

 -- Roman Lebedev <lebedev.ri@gmail.com>  Thu, 06 Jan 2022 15:14:53 +0300

halide (13.0.2-2) unstable; urgency=medium

  * Another RISC-V build fix
  * Instruct CTest to rerun failed tests a few times to weed out
    intermitten test failures
  * Rebuild to pacify intermitten test failures

 -- Roman Lebedev <lebedev.ri@gmail.com>  Sun, 19 Dec 2021 13:33:16 +0300
